Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.

Bug 230052

Summary: ls -lL displays dangling symlinks with full path
Product: [Fedora] Fedora Reporter: Emmanuel Thomé <emmanuel.thome>
Component: coreutilsAssignee: Tim Waugh <twaugh>
Status: CLOSED ERRATA QA Contact:
Severity: low Docs Contact:
Priority: medium    
Version: 6CC: meyering
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: 5.97-12.5.fc6 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2007-04-19 08:25:16 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 207681    

Description Emmanuel Thomé 2007-02-26 10:47:35 UTC
Description of problem:

ls -lL displays dangling symlinks with full path.

Version-Release number of selected component (if applicable):
coreutils-5.97-12.2.fc6


How reproducible:
always

Steps to Reproduce:
  
dixsept /tmp $ mkdir a ; touch a/b ; ln -s d a/c ; ls -lL a
total 0
?--------- ? ?     ?      ?            ? a/c
-rw-r--r-- 1 thome spaces 0 Feb 26 11:42 b
dixsept /tmp $ touch a/d ; ls -lL a
total 0
-rw-r--r-- 1 thome spaces 0 Feb 26 11:42 b
-rw-r--r-- 1 thome spaces 0 Feb 26 11:42 c
-rw-r--r-- 1 thome spaces 0 Feb 26 11:42 d

Expected results:

The question marks aren't really a problem. However I find it quite odd to have
``a/c'' displayed in the first example, while I would have expected a plain ``c''.

Previous versions of coreutils failed with ``a/c: No such file or directory''.
It's neat to still display the file, but it would be even better to have the
basename displayed.


Additional info:

Might be NOTABUG if there's a good rationale for it...

Comment 1 Jim Meyering 2007-02-26 10:56:56 UTC
Thanks for the report.
FYI, this is fixed in newer versions.
With coreutils-6.7-8.fc7, I get this:

    $ mkdir a ; touch a/b ; ln -s d a/c ; /bin/ls -lL a
    /bin/ls: cannot access a/c: No such file or directory
    total 0
    -rw-r--r-- 1 meyering meyering 0 Feb 26 11:53 b
    l????????? ? ?        ?        ?            ? c


Comment 2 Tim Waugh 2007-02-26 11:23:06 UTC
I'll add this to the list of things to backport to FC-6.

Comment 3 Jim Meyering 2007-02-26 11:40:19 UTC
Thanks, Tim.
BTW, here's the upstream patch that fixed it:
http://git.sv.gnu.org/gitweb/?p=coreutils.git;a=commit;h=9e0a095be64

Comment 4 Tim Waugh 2007-04-17 11:48:30 UTC
Actually it turned out that the real bug was in the SELinux patch.  Here is that
fix:

--- coreutils-5.97/src/ls.c     2006-10-03 17:18:16.000000000 +0100
+++ coreutils-5.97/src/ls.c     2006-10-03 17:18:16.000000000 +0100
@@ -2690,7 +2690,7 @@
          f->filetype = type;
          memset (&f->stat, '\0', sizeof (f->stat));
 
-         f->name = xstrdup (absolute_name);
+         f->name = xstrdup (name);
          files_index++;
 
          return 0;


Comment 5 Fedora Update System 2007-04-18 22:37:32 UTC
Fixed in update: coreutils-5.97-12.5.fc6